package dev.shadowsoffire.apotheosis.spawn.modifiers;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.mojang.datafixers.util.Pair;
import com.mojang.serialization.DynamicOps;
import com.mojang.serialization.JsonOps;
import dev.shadowsoffire.apotheosis.spawn.SpawnerModule;
import dev.shadowsoffire.apotheosis.spawn.modifiers.SpawnerStat;
import dev.shadowsoffire.apotheosis.spawn.modifiers.SpawnerStats;
import dev.shadowsoffire.apotheosis.spawn.spawner.ApothSpawnerTile;
import java.util.Objects;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.nbt.NbtOps;
import net.minecraft.network.FriendlyByteBuf;

public final class StatModifier<T> extends Record {
  private final SpawnerStat<T> stat;
  
  private final T value;
  
  private final T min;
  
  private final T max;
  
  public StatModifier(SpawnerStat<T> stat, T value, T min, T max) {
    this.stat = stat;
    this.value = value;
    this.min = min;
    this.max = max;
  }
  
  public final String toString() {
    // Byte code:
    //   0: aload_0
    //   1: <illegal opcode> toString : (Ldev/shadowsoffire/apotheosis/spawn/modifiers/StatModifier;)Ljava/lang/String;
    //   6: areturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #13	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	7	0	this	Ldev/shadowsoffire/apotheosis/spawn/modifiers/StatModifier;
    // Local variable type table:
    //   start	length	slot	name	signature
    //   0	7	0	this	Ldev/shadowsoffire/apotheosis/spawn/modifiers/StatModifier<TT;>;
  }
  
  public final int hashCode() {
    // Byte code:
    //   0: aload_0
    //   1: <illegal opcode> hashCode : (Ldev/shadowsoffire/apotheosis/spawn/modifiers/StatModifier;)I
    //   6: ireturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #13	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	7	0	this	Ldev/shadowsoffire/apotheosis/spawn/modifiers/StatModifier;
    // Local variable type table:
    //   start	length	slot	name	signature
    //   0	7	0	this	Ldev/shadowsoffire/apotheosis/spawn/modifiers/StatModifier<TT;>;
  }
  
  public final boolean equals(Object o) {
    // Byte code:
    //   0: aload_0
    //   1: aload_1
    //   2: <illegal opcode> equals : (Ldev/shadowsoffire/apotheosis/spawn/modifiers/StatModifier;Ljava/lang/Object;)Z
    //   7: ireturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #13	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	8	0	this	Ldev/shadowsoffire/apotheosis/spawn/modifiers/StatModifier;
    //   0	8	1	o	Ljava/lang/Object;
    // Local variable type table:
    //   start	length	slot	name	signature
    //   0	8	0	this	Ldev/shadowsoffire/apotheosis/spawn/modifiers/StatModifier<TT;>;
  }
  
  public SpawnerStat<T> stat() {
    return this.stat;
  }
  
  public T value() {
    return this.value;
  }
  
  public T min() {
    return this.min;
  }
  
  public T max() {
    return this.max;
  }
  
  public boolean apply(ApothSpawnerTile tile) {
    return this.stat.apply(this.value, this.min, this.max, tile);
  }
  
  public void write(FriendlyByteBuf buf) {
    buf.m_130072_(this.stat.getId(), 32);
    Objects.requireNonNull(SpawnerModule.LOG);
    buf.m_130079_((CompoundTag)this.stat.getModifierCodec().encodeStart((DynamicOps)NbtOps.f_128958_, this).getOrThrow(false, SpawnerModule.LOG::error));
  }
  
  public static dev.shadowsoffire.apotheosis.spawn.modifiers.StatModifier<?> read(FriendlyByteBuf buf) {
    SpawnerStat<?> stat = (SpawnerStat)SpawnerStats.REGISTRY.get(buf.m_130136_(32));
    Objects.requireNonNull(SpawnerModule.LOG);
    return (dev.shadowsoffire.apotheosis.spawn.modifiers.StatModifier)((Pair)stat.getModifierCodec().decode((DynamicOps)NbtOps.f_128958_, buf.m_130260_()).getOrThrow(false, SpawnerModule.LOG::error)).getFirst();
  }
  
  public static dev.shadowsoffire.apotheosis.spawn.modifiers.StatModifier<?> parse(JsonObject obj) {
    SpawnerStat<?> stat = (SpawnerStat)SpawnerStats.REGISTRY.get(obj.get("id").getAsString());
    if (stat == null)
      throw new JsonParseException("Failed to parse a stat modifier - missing or invalid ID"); 
    Objects.requireNonNull(SpawnerModule.LOG);
    return (dev.shadowsoffire.apotheosis.spawn.modifiers.StatModifier)((Pair)stat.getModifierCodec().decode((DynamicOps)JsonOps.INSTANCE, obj).getOrThrow(false, SpawnerModule.LOG::error)).getFirst();
  }
}
